(*
    ===========================================================================

    w肳ꂽtH_BEt@CB̒Aw肳ꂽgqt@C
    AXgAbvBtH_̏ꍇ͍ċAIɑSẴtH_Ɋ܂܂
    t@C`FbNΏۂƂB͂B
    -----------------------------------------------------------------
    2003/12/18  쐬

    ===========================================================================
*)

unit ScanFile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TScanFileForm = class(TForm)
    ImgAppIcon: TImage;
    Label1: TLabel;
    Label2: TLabel;
    LblDirectory: TLabel;
    LblFile: TLabel;
    LblExtensions: TLabel;
    LblCount: TLabel;
    BtnAbort: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure BtnAbortClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    inExtensions: string;
    inSrcFiles  : TStrings;
    inSrcFolders: TStrings;
    inIgnoreFoders: TStrings;
    outResults  : TStrings;

    Aborted     : Boolean;
    EXTENSIONS  : string;
    procedure   OnFindFile(const APath: string; const ALevel: integer; var Stop: Boolean);
    procedure   OnFindFolder(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean);

    procedure   ScanStart();
    procedure   CheckFiles();
    procedure   CheckFolders();
  public

  end;

procedure   ScanFiles(AExtensions: string; AFiles, AFolders, AIgnoreFolders, AResult: TStrings);

implementation

{$R *.dfm}

(*
    ===========================================================================
    OJptH[쐬֐
    ===========================================================================
*)
procedure   ScanFiles(AExtensions: string; AFiles, AFolders, AIgnoreFolders, AResult: TStrings);
var
    ScanFileForm: TScanFileForm;
begin
    Application.BringToFront;
    ScanFileForm := TScanFileForm.Create(Application);
    try
        ScanFileForm.inExtensions := AExtensions;
        ScanFileForm.inSrcFiles := AFiles;
        ScanFileForm.inSrcFolders := AFolders;
        ScanFileForm.inIgnoreFoders := AIgnoreFolders;
        ScanFileForm.outResults := AResult;
        ScanFileForm.Show;
        ScanFileForm.ScanStart();
    finally
        ScanFileForm.Free;        
    end;
end;

(*
    =================================================================
    ܂悤ɕ\
    -----------------------------------------------------------------
    [Borland]\CBuilder5\Source\Vcl\filectrl.pas
    =================================================================
*)
procedure CutFirstDirectory(var S: TFileName);
var
  Root: Boolean;
  P: Integer;
begin
  if S = '\' then
    S := ''
  else
  begin
    if S[1] = '\' then
    begin
      Root := True;
      Delete(S, 1, 1);
    end
    else
      Root := False;
    if S[1] = '.' then
      Delete(S, 1, 4);
    P := AnsiPos('\',S);
    if P <> 0 then
    begin
      Delete(S, 1, P);
      S := '...\' + S;
    end
    else
      S := '';
    if Root then
      S := '\' + S;
  end;
end;

(*
    =================================================================
    ܂悤ɕ\({)
    -----------------------------------------------------------------
    [Borland]\CBuilder5\Source\Vcl\filectrl.pas
    =================================================================
*)
function MinimizeName(const Filename: TFileName; Canvas: TCanvas;
  MaxLen: Integer): TFileName;
var
  Drive: TFileName;
  Dir: TFileName;
  Name: TFileName;
begin
  Result := FileName;
  Dir := ExtractFilePath(Result);
  Name := ExtractFileName(Result);

  if (Length(Dir) >= 2) and (Dir[2] = ':') then
  begin
    Drive := Copy(Dir, 1, 2);
    Delete(Dir, 1, 2);
  end
  else
    Drive := '';
  while ((Dir <> '') or (Drive <> '')) and (Canvas.TextWidth(Result) > MaxLen) do
  begin
    if Dir = '\...\' then
    begin
      Drive := '';
      Dir := '...\';
    end
    else if Dir = '' then
      Drive := ''
    else
      CutFirstDirectory(Dir);
    Result := Drive + Dir + Name;
  end;
end;

(*
    =================================================================
    ċAItH_
    -----------------------------------------------------------------
    Subject: [Delphi-ML:4452] Re: fBNg\𓾂ɂ́H
    =================================================================
*)
type
    TOnFindFile = procedure(const APath: string; const ALevel: integer; var Stop: Boolean) of object;
    TOnFindFolder = procedure(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean) of object;

function    FindFiles(const ADirPath: string; const ALevel: integer;
                ACallbackFile: TOnFindFile; ACallbackFolder: TOnFindFolder): Boolean;
var
    Path: string;
    Rec: TSearchRec;
    Skip, Cancel: Boolean;
begin

    Result := True;
    Path := ADirPath;

    // ȃtH_H
    if not DirectoryExists(Path) then Exit;

    // \ ĂH
    if Path[Length(Path)] <> '\' then Path := Path + '\';

    // Ȃ񂩓Ă邩ȁH
    if FindFirst(Path + '*.*', faAnyFile, Rec) = 0 then
    begin

        // Ă݂悤
        try
            repeat
                // tH_ƐetH_͖
                if (Rec.Name = '.') or (Rec.Name = '..') then Continue;

                // XLbvȂˁH
                Skip := False;

                // LZȂˁH
                Cancel := False;

                // tH_
                if (Rec.Attr and faDirectory) <> 0 then
                begin
                    ACallbackFolder(Path + Rec.Name, ALevel, Skip, Cancel);

                    // HXLbv...
                    if Skip then Continue;

                    // HLZ...
                    if Cancel then
                    begin
                        Result := False;
                        Break;
                    end;

                    // @@
                    Result := FindFiles(Path + Rec.Name, ALevel + 1, ACallbackFile, ACallbackFolder);

                    // BLZꂽB
                    if not Result then Break;
                end else
                begin

                    // R[obN
                    ACallbackFile(Path + Rec.Name, ALevel, Cancel);

                    // HLZ...
                    if Cancel then
                    begin
                        Result := False;
                        Break;
                    end;

                end;

            until
                // ǂ܂ł
                FindNext(Rec) <> 0;
        finally
            // Еt
            FindClose(Rec);
        end;

    end;
end;

(*
    =================================================================
    t@C
    =================================================================
*)
procedure   TScanFileForm.OnFindFile(const APath: string; const ALevel: integer; var Stop: Boolean);
var
    ext: string;
begin
    //  Ƌx
    Sleep(1);
    //  t@C\
    LblFile.Caption := ExtractFileName(APath);
    //  gqo
    ext := UpperCase(ExtractFileExt(APath));
    //  ΏۂȂ
    if (FileExists(APath)) and (Pos(ext, EXTENSIONS) > 0) then
    begin
        //  L^
        outResults.Add(APath);
    end;
    //  \
    LblCount.Caption := Format('%d file(s) are found.', [outResults.Count]);
    //  LZĂȂȁH
    Application.ProcessMessages;
    //  ǂȁH
    Stop := Aborted;
end;

(*
    =================================================================
    tH_[
    =================================================================
*)
procedure   TScanFileForm.OnFindFolder(const APath: string; const ALevel: integer; var Skip: Boolean; var Stop: Boolean);
begin
    //  tH_\
    LblDirectory.Caption := MinimizeName(APath, Self.Canvas, LblDirectory.Width);
    //  tH_łH
    if (inIgnoreFoders <> nil) then
    begin
        //  XLbv܂傩H
        Skip := (inIgnoreFoders.IndexOf(APath) <> -1);
    end;
    //  LZĂȂȁH
    Application.ProcessMessages;
    //  ǂȁH
    Stop := Aborted;
end;

(*
    =================================================================
    󂯎t@C̃`FbN
    =================================================================
*)
procedure   TScanFileForm.CheckFiles();
var
    i: integer;
    Stop: Boolean;
begin
    //  t@CB͂邩ȁH
    if (inSrcFiles = nil) then Exit;
    //  et@Cɑ΂
    for i := 0 to inSrcFiles.Count - 1 do
    begin
        //  Ă݂
        OnFindFile(inSrcFiles[i], -1, Stop);
        //  LZȂI
        if Stop then Break;
    end;
end;

(*
    =================================================================
    󂯎tH_̃`FbN
    =================================================================
*)
procedure   TScanFileForm.CheckFolders();
var
    i: integer;
begin
    //  tH_B͂邩ȁH
    if (inSrcFolders = nil) then Exit;
    //  etH_ɑ΂
    for i := 0 to inSrcFolders.Count - 1 do
    begin
        //  ċAĂ݂悤
        if not (FindFiles(inSrcFolders[i], 0, OnFindFile, OnFindFolder)) then Break;
    end;
end;

(*
    =================================================================
    \
    =================================================================
*)
procedure TScanFileForm.FormShow(Sender: TObject);
begin
    //  Ώۂ̊gq啶
    EXTENSIONS := UpperCase(inExtensions);
    //  ʃNA
    outResults.Clear;
    //  \
    LblExtensions.Caption := EXTENSIONS;
end;

(*
    =================================================================
    Jn
    =================================================================
*)
procedure   TScanFileForm.ScanStart();
begin
    //  t@C
    CheckFiles();
    //  tH_
    CheckFolders();
end;

(*
    =================================================================
    ~{^
    =================================================================
*)
procedure TScanFileForm.BtnAbortClick(Sender: TObject);
begin
    //  tO
    Aborted := true;
end;

(*
    =================================================================
    tH[RXgN^
    =================================================================
*)
procedure TScanFileForm.FormCreate(Sender: TObject);
begin
    //  tOQ
    Aborted := false;
    //  AvP[ṼACRȂƂȂ\
    ImgAppIcon.Picture.Icon.Assign(Application.Icon);
end;

end.

