unit idao;

interface

uses
    Windows, Classes, SysUtils, Variants, ActiveX, ComObj;

type
    //  ڑEؒfNX
    TDao360Base = class
    private
        FOpened: Boolean;
    protected
        FENGINE: OleVariant;
        FWORKSPACE: OleVariant;
        FDATABASE: OleVariant;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure OpenConnection(const Path, Pass: string);
        procedure CloseConnection();
        function this(): TDao360Base;
        property Opened: Boolean read FOpened;
        property DB: OleVariant read FDATABASE;
    end;

    //  ̓NX
    TDao360Html = class(TDao360Base)
    private
        F: TextFile;
        FStrings: TStrings;

        procedure DoMessage(const Msg: string; const Level: Byte = 0);
        procedure DoAnalyzeFile(const OutPath, FileName, Password: string);

        procedure PutHtmlHead(const FileName: string);
        procedure PutTableItiran();
        procedure PutTableDetail();

        procedure PutEngineProp();
        procedure PutWorkspaceProp();
        procedure PutDatabaseProp();
        procedure PutHtmlFoot();
    public
        procedure DoAnalyze(const OutPath: string; Strings: TStrings);
        constructor Create();
        destructor Destroy(); override;
    end;

implementation

uses
    StrUtils, idaodata, idaoconst;

//  ===========================================================================
//  Utility
//  ===========================================================================

//  -------------------------------------------------
//  "<"">""&"AHTMLŐ\邽߂̕ϊ
//  -------------------------------------------------
function ChangeHTMLSpecialChar(text: string): string;
var
    i: integer;
    src, dest: array[0..2] of string;
begin
    //"&"ŏɕϊƂȂƑςȂƂ
    src[0] := '&';  dest[0] := '&amp;';
    src[1] := '<';  dest[1] := '&lt;';
    src[2] := '>';  dest[2] := '&gt;';
    //ϊRs[
    Result := Text;
    //bAfor i := 0 to 2 do
    for i := Low(src) to High(src) do
    begin
        //uĂ邾
        Result := StringReplace(Result, src[i], dest[i], [rfReplaceAll]);
    end;
end;

//  ===========================================================================
//  TData360Base
//  ===========================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TDao360Base.Create();
begin
    FENGINE := CreateOleObject('DAO.DBEngine.36');
    FWORKSPACE := FENGINE.Workspaces[0];
    FDATABASE := Unassigned;
    FOpened := false;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TDao360Base.Destroy();
begin
    CloseConnection();
    FWORKSPACE := Unassigned;
    FENGINE := Unassigned;
end;

//-----------------------------------------------------------------------------
//  ڑ
procedure TDao360Base.OpenConnection(const Path, Pass: string);
var
    pwd: string;
begin
    //  pX[hw蕶
    pwd := Format(';pwd=%s', [Pass]);
    try
        //  LEǎpŊJ
        FDATABASE := FWORKSPACE.OpenDatabase(Path, false, true, pwd);
        //  J
        FOpened := true;
    except
        raise;
    end;
end;

//-----------------------------------------------------------------------------
//  ؒf
procedure TDao360Base.CloseConnection();
begin
    if FOpened then FDATABASE.Close;
    FOpened := false;
    FDATABASE := Unassigned;
end;

//-----------------------------------------------------------------------------
//  ւ̎Q
function TDao360Base.this(): TDao360Base;
begin
    Result := Self;
end;

//  ===========================================================================
//  TData360Html
//  ===========================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TDao360Html.Create();
begin
    inherited;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TDao360Html.Destroy();
begin
    inherited;
end;

//-----------------------------------------------------------------------------
//  bZ[Wo
procedure TDao360Html.DoMessage(const Msg: string; const Level: Byte = 0);
const
    S_LEVEL = '  ';
var
    T: string;
begin
    T := FormatDateTime('hh:nn:ss', Now());
    FStrings.Add(Format('%s %s%s', [T, DupeString(S_LEVEL, Level), Msg]));
end;

//-----------------------------------------------------------------------------
//  ̓Gg[
procedure TDao360Html.DoAnalyze(const OutPath: string; Strings: TStrings);
var
    Tick: Cardinal;
    i, Count: integer;
    MdbInfo: TMdbFile;
begin
    FStrings := Strings;
    try
        Tick := GetTickCount();
        DoMessage('͂Jn܂B');
        DoMessage(StringOfChar('-', 50));
        Count := MdbFiles.Count;

        for i := 0 to Count - 1 do
        begin
            //  t@CNXo
            MdbInfo := TMdbFile(MdbFiles[i]);
            DoMessage(Format('[%2d/%2d] ͊Jn %s', [i + 1, Count, MdbInfo.DispName]));

            //  ڑmFς݂̏ꍇ̂
            if (MdbInfo.Status = fsNoProblem) then
            begin
                ForceDirectories(OutPath);
                DoAnalyzeFile(OutPath, MdbInfo.FileName, MdbInfo.Password);
            end
            else
            begin
                DoMessage('ڑ`FbN̂߃X[܂B');
            end;
        end;

        DoMessage(StringOfChar('-', 50));
        Tick := GetTickCount() - Tick;
        DoMessage(Format('v %.3fb', [Tick / 1000]));
    finally
    end;

end;

//-----------------------------------------------------------------------------
//  (1t@C)
procedure TDao360Html.DoAnalyzeFile(const OutPath, FileName, Password: string);
var
    OutFile: string;
begin
    //  o͐挈
    OutFile := OutPath + ExtractFileName(ChangeFileExt(FileName, '.html'));

    try
        //  ڑ
        OpenConnection(FileName, Password);
        DoMessage('ڑ܂B', 1);
        try
            try
                //  t@CJ
                AssignFile(F, OutFile);
                Rewrite(F);
                try
                    //   HTMLwb_o
                    PutHtmlHead(FileName);

                    //   e[uꗗo
                    DoMessage('e[uꗗo͒...', 1);
                    PutTableItiran();

                    //   tB[h\o
                    DoMessage('tB[h\o͒...', 1);
                    PutTableDetail();

                    //   ڑGWvpeBo
                    DoMessage('ڑGW̃vpeBo͒...', 1);
                    PutEngineProp();

                    //   [NXy[XvpeBo
                    DoMessage('[NXy[X̃vpeBo͒...', 1);
                    PutWorkspaceProp();

                    //   f[^x[XvpeBo
                    DoMessage('f[^x[X̃vpeBo͒...', 1);
                    PutDatabaseProp();

                    //   HTMLtb^o
                    PutHtmlFoot();
                finally
                    //  t@C
                    CloseFile(F);
                end;
            except
                on E:Exception do DoMessage(E.Message, 1);
            end;
        finally
            //  ؒf
            CloseConnection();
            DoMessage('ؒf܂B', 1);
        end;
    except
        on E:Exception do DoMessage(E.Message, 1);
    end;
end;

//-----------------------------------------------------------------------------
//  HTML̃wb_o
procedure TDao360Html.PutHtmlHead(const FileName: string);
begin
    Writeln(F, '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
    Writeln(F, '<html lang="ja"><head>');
    Writeln(F, '<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">');
    Writeln(F, '<meta http-equiv="Content-Script-Type" content="text/javascript">');
    Writeln(F, '<meta http-equiv="Content-Style-Type" content="text/css">');
    Writeln(F, '<link rev="made" href="mailto:fjtkt@ybb.ne.jp">');
    Writeln(F, '<style type="text/css"><!--');
    Writeln(F, 'body,table{font-size:x-small;}');
    Writeln(F, 'body{font-family:sans-serif;}');
    Writeln(F, 'table{font-family:monospace;}');
    Writeln(F, 'th{background-color:#666666;color:#ffffff;}');
    Writeln(F, '--></style>');
    Writeln(F, Format('<title>%s ͌</title>', [ExtractFileName(FileName)]));
    Writeln(F, '</head><body>');

    Writeln(F, Format('<p id="PAGE_TOP">Generated by %s at %s</p>', [ExtractFileName(ParamStr(0)), FormatDateTime('yyyy/mm/dd hh:nn:ss', Now())]));
    Writeln(F, Format('<h1>%s ͌</h1>', [ExtractFileName(FileName)]));
end;

//-----------------------------------------------------------------------------
//  HTML̃tb^o
procedure TDao360Html.PutHtmlFoot();
begin
    Writeln(F, '<p><a href="#PAGE_TOP">TOP</a></p></body></html>');
end;

//-----------------------------------------------------------------------------
//  # GW̃vpeB
procedure TDao360Html.PutEngineProp();
var
    i: integer;
    PROP: OleVariant;
    PropNam, PropVal: string;
begin
    Writeln(F, '<h2>ڑGW̃vpeB</h2>');
    Writeln(F, '<table border=1 cellpadding=3 cellspacing=0 summary="ڑGW̃vpeB">');
    Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

    for i := 0 to FENGINE.Properties.Count - 1 do
    begin
        try
            PROP := FENGINE.Properties[i];
            PropNam := PROP.Name;
            PropVal := PROP.Value;
        except
            ;   //  Ԃ
        end;
        Writeln(F, Format('<tr><td>%d</td><td>%s</td><td>%s@</td></tr>',
                          [i + 1, PropNam, ChangeHTMLSpecialChar(PropVal)])
        );
    end;
    Writeln(F, '</table>');
end;

//-----------------------------------------------------------------------------
//  # [NXy[X̃vpeB
procedure TDao360Html.PutWorkspaceProp();
var
    i: integer;
    PROP: OleVariant;
    PropNam, PropVal: string;
begin
    Writeln(F, '<h2>[NXy[X̃vpeB</h2>');
    Writeln(F, '<table border=1 cellpadding=3 cellspacing=0 summary="[NXy[X̃vpeB">');
    Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

    for i := 0 to FWORKSPACE.Properties.Count - 1 do
    begin
        try
            PROP := FWORKSPACE.Properties[i];
            PropNam := PROP.Name;
            PropVal := PROP.Value;
        except
            ;   //  Ԃ
        end;
        Writeln(F, Format('<tr><td>%d</td><td>%s</td><td>%s@</td></tr>',
                          [i + 1, PropNam, ChangeHTMLSpecialChar(PropVal)])
        );
    end;
    Writeln(F, '</table>');
end;

//-----------------------------------------------------------------------------
//  # f[^x[X̃vpeB
procedure TDao360Html.PutDatabaseProp();
var
    i: integer;
    PROP: OleVariant;
    PropNam, PropVal: string;
begin
    Writeln(F, '<h2>f[^x[X̃vpeB</h2>');
    Writeln(F, '<table border=1 cellpadding=3 cellspacing=0 summary="f[^x[X̃vpeB">');
    Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

    for i := 0 to FDATABASE.Properties.Count - 1 do
    begin
        try
            PROP := FDATABASE.Properties[i];
            PropNam := PROP.Name;
            PropVal := PROP.Value;
        except
            ;   //  Ԃ
        end;
        Writeln(F, Format('<tr><td>%d</td><td>%s</td><td>%s@</td></tr>',
                          [i + 1, PropNam, ChangeHTMLSpecialChar(PropVal)])
        );
    end;
    Writeln(F, '</table>');
end;

//-----------------------------------------------------------------------------
//  # e[uꗗ
procedure TDao360Html.PutTableItiran();
var
    i, TableCount: integer;
    TABLE: OleVariant;
begin
    Writeln(F, '<h2>e[uꗗ</h2>');

    //  e[u邩ǂ`FbN
    TableCount := FDATABASE.TableDefs.Count;
    //  ΂邱ƂȂ
    if (TableCount = 0) then
    begin
        Writeln(F, '<p>e[u݂܂B</p>');
        exit;
    end;

    //  <TABLE>̌Œ^Cg쐬
    Writeln(F, '<table border=1 cellpadding=3 cellspacing=0 summary="e[uꗗ">');
    Write(F, '<tr><th nowrap>NO</th>'
             +    '<th nowrap></th>'
             +    '<th nowrap></th>'
             +    '<th nowrap>쐬</th>'
             +    '<th nowrap>XV</th>'
             //+    '<th nowrap>ConflictTable</th>' ԐH
             +    '<th nowrap>Connect</th>'
             +    '<th nowrap></th>'
             //+    '<th nowrap>ReplicaFilter</th>' ԐH
             +    '<th nowrap>\</th>'
             +    '<th nowrap>XV\</th>'
             +    '<th nowrap>͋K</th>'
             +    '<th nowrap>K</th>'
             +    '<th nowrap></th>'
             );
    Writeln(F, '</tr>');

    //  e[ũvpeBo
    for i := 0 to TableCount - 1 do
    begin
        //  e[uIuWFNgo
        TABLE := FDATABASE.TableDefs[i];
        //  󋵒ʒm
        DoMessage(Format('[%2d/%2d] %s', [i + 1, TableCount, TABLE.Name]), 2);
        Writeln(F, '<tr>');
        //  vpeBo
        Write(F, Format('<td>%d</td>', [i + 1]));
        Write(F, Format('<td id="TABLE%d" nowrap><a href="#FIELD%d">%s</a></td>', [i + 1, i + 1, TABLE.Name]));
        Write(F, Format('<td>%s</td>', [TableDefAttributeEnum2Str(TABLE.Attributes)]));
        Write(F, Format('<td>%s</td>', [TABLE.DateCreated]));
        Write(F, Format('<td>%s</td>', [TABLE.LastUpdated]));
        //Write(F, Format('<td>%s@</td>', [VarToStr(TABLE.ConflictTable)]));
        Write(F, Format('<td>%s@</td>', [TABLE.Connect]));
        Write(F, Format('<td>%s</td>', [TABLE.RecordCount]));
        //Write(F, Format('<td>%s@</td>', [VarToStr(TABLE.ReplicaFilter)]));
        Write(F, Format('<td>%s@</td>', [TABLE.SourceTableName]));
        Write(F, Format('<td>%s@</td>', [TABLE.Updatable]));
        Write(F, Format('<td>%s@</td>', [ChangeHTMLSpecialChar(TABLE.ValidationRule)]));
        Write(F, Format('<td>%s@</td>', [ChangeHTMLSpecialChar(TABLE.ValidationText)]));
        try
            Write(F, Format('<td>%s@</td>', [TABLE.Properties('Description')]));
        except
            Write(F, Format('<td>%s@</td>', ['']));
        end;
        Writeln(F, '</tr>');
    end;

    Writeln(F, '</table>');
end;

//-----------------------------------------------------------------------------
//  tB[h\o
procedure TDao360Html.PutTableDetail();

    function IfSameThenNullElseLeft(const Left, Rite: string): string;
    begin
        if (Left = Rite) then Result := '' else Result := Left; 
    end;

var
    i, j, TableCount, FieldCount: integer;
    TABLE: OleVariant;
    FIELD: OleVariant;
begin
    Writeln(F, '<h2>tB[h\</h2>');

    //  e[u邩ǂ`FbN
    TableCount := FDATABASE.TableDefs.Count;
    //  ΂邱ƂȂ
    if (TableCount = 0) then
    begin
        Writeln(F, '<p>e[u݂܂B</p>');
        exit;
    end;

    //  ee[uƂɏo
    for i := 0 to TableCount - 1 do
    begin
        //  e[uIuWFNgo
        TABLE := FDATABASE.TableDefs[i];

        //  ^Cgo
        DoMessage(Format('[%2d/%2d] %s', [i + 1, TableCount, TABLE.Name]), 2);
        Writeln(F, Format('<h3 id="FIELD%d"><a href="#TABLE%d" title="detail">%s</a></h3>', [i + 1, i + 1, TABLE.Name]));

        //  tB[h`FbN
        FieldCount := TABLE.Fields.Count;
        if (FieldCount = 0) then
        begin
            Writeln(F, '<p>tB[h݂܂B</p>');
            continue;
        end;

        //  <TABLE>̌Œ^Cg쐬
        Writeln(F, Format('<table border=1 cellpadding=3 cellspacing=0 summary="%s̃tB[h\">', [TABLE.Name]));
        Write(F, '<tr><th nowrap></th>'
                 +    '<th nowrap></th>'
                 +    '<th nowrap>󕶎</th>'
                 +    '<th nowrap></th>'
                 //+    '<th nowrap>CollatingOrder</th>'
                 +    '<th nowrap>XV\</th>'
                 +    '<th nowrap>l</th>'
                 +    '<th nowrap>NULLs</th>'
                 +    '<th nowrap>TCY</th>'
                 +    '<th nowrap></th>'
                 +    '<th nowrap>\</th>'
                 +    '<th nowrap>^</th>'
                 +    '<th nowrap>͋K</th>'
                 +    '<th nowrap>K</th>'
                 +    '<th nowrap></th>'
                 );
        Writeln(F, '</tr>');

        //  e[ũvpeBo
        for j := 0 to FieldCount - 1 do
        begin
            //  tB[hIuWFNgo
            FIELD := TABLE.Fields[j];
            //  󋵒ʒm
            DoMessage(Format('[%2d/%2d] %s', [j + 1, FieldCount, FIELD.Name]), 3);
            Writeln(F, '<tr>');
            //  vpeBo
            Write(F, Format('<td>%s</td>', [FIELD.OrdinalPosition]));
            Write(F, Format('<td nowrap>%s</td>', [FIELD.Name]));
            Write(F, Format('<td>%s</td>', [FIELD.AllowZeroLength]));
            Write(F, Format('<td>%s</td>', [FIELD.Attributes]));
            //Write(F, Format('<td>%s</td>', [FIELD.CollatingOrder]));
            Write(F, Format('<td>%s</td>', [FIELD.DataUpdatable]));
            Write(F, Format('<td>%s@</td>', [FIELD.DefaultValue]));
            Write(F, Format('<td>%s</td>', [FIELD.Required]));
            Write(F, Format('<td>%s</td>', [FIELD.Size]));
            Write(F, Format('<td>%s@</td>', [IfSameThenNullElseLeft(FIELD.SourceField, FIELD.Name)]));
            Write(F, Format('<td>%s@</td>', [IfSameThenNullElseLeft(FIELD.SourceTable, TABLE.Name)]));
            Write(F, Format('<td>%s</td>', [FIELD.Type]));
            Write(F, Format('<td>%s@</td>', [ChangeHTMLSpecialChar(FIELD.ValidationRule)]));
            Write(F, Format('<td>%s@</td>', [ChangeHTMLSpecialChar(FIELD.ValidationText)]));
            try
                Write(F, Format('<td>%s@</td>', [ChangeHTMLSpecialChar(FIELD.Properties('Description'))]));
            except
                Write(F, Format('<td>%s@</td>', ['']));
            end;
            Writeln(F, '</tr>');
        end;

        Writeln(F, '</table>');
    end;
end;

//-----------------------------------------------------------------------------
//  /I
initialization
    CoInitialize(nil);
finalization
    CoUninitialize();
end.

