unit idaoconst;

interface

uses
    SysUtils;

const
  // ^CvCũW[/}Ci[o[Wԍ
  DAOMajorVersion = 5;
  DAOMinorVersion = 0;

// *********************************************************************//
// Declaration of Enumerations defined in Type Library                    
// *********************************************************************//
// enum RecordsetTypeEnum ̂߂̒萔
const
  dbOpenTable = $00000001;
  dbOpenDynaset = $00000002;
  dbOpenSnapshot = $00000004;
  dbOpenForwardOnly = $00000008;
  dbOpenDynamic = $00000010;

// enum EditModeEnum ̂߂̒萔
const
  dbEditNone = $00000000;
  dbEditInProgress = $00000001;
  dbEditAdd = $00000002;

// enum RecordsetOptionEnum ̂߂̒萔
const
  dbDenyWrite = $00000001;
  dbDenyRead = $00000002;
  dbReadOnly = $00000004;
  dbAppendOnly = $00000008;
  dbInconsistent = $00000010;
  dbConsistent = $00000020;
  dbSQLPassThrough = $00000040;
  dbFailOnError = $00000080;
  dbForwardOnly = $00000100;
  dbSeeChanges = $00000200;
  dbRunAsync = $00000400;
  dbExecDirect = $00000800;

// enum LockTypeEnum ̂߂̒萔
const
  dbPessimistic = $00000002;
  dbOptimistic = $00000003;
  dbOptimisticValue = $00000001;
  dbOptimisticBatch = $00000005;

// enum UpdateCriteriaEnum ̂߂̒萔
const
  dbCriteriaKey = $00000001;
  dbCriteriaModValues = $00000002;
  dbCriteriaAllCols = $00000004;
  dbCriteriaTimestamp = $00000008;
  dbCriteriaDeleteInsert = $00000010;
  dbCriteriaUpdate = $00000020;

// enum FieldAttributeEnum ̂߂̒萔
const
  dbFixedField = $00000001;
  dbVariableField = $00000002;
  dbAutoIncrField = $00000010;
  dbUpdatableField = $00000020;
  dbSystemField = $00002000;
  dbHyperlinkField = $00008000;
  dbDescending = $00000001;

// enum DataTypeEnum ̂߂̒萔
const
  dbBoolean = $00000001;
  dbByte = $00000002;
  dbInteger = $00000003;
  dbLong = $00000004;
  dbCurrency = $00000005;
  dbSingle = $00000006;
  dbDouble = $00000007;
  dbDate = $00000008;
  dbBinary = $00000009;
  dbText = $0000000A;
  dbLongBinary = $0000000B;
  dbMemo = $0000000C;
  dbGUID = $0000000F;
  dbBigInt = $00000010;
  dbVarBinary = $00000011;
  dbChar = $00000012;
  dbNumeric = $00000013;
  dbDecimal = $00000014;
  dbFloat = $00000015;
  dbTime = $00000016;
  dbTimeStamp = $00000017;

// enum RelationAttributeEnum ̂߂̒萔
const
  dbRelationUnique = $00000001;
  dbRelationDontEnforce = $00000002;
  dbRelationInherited = $00000004;
  dbRelationUpdateCascade = $00000100;
  dbRelationDeleteCascade = $00001000;
  dbRelationLeft = $01000000;
  dbRelationRight = $02000000;

// enum TableDefAttributeEnum ̂߂̒萔
const
  dbAttachExclusive = $00010000;
  dbAttachSavePWD = $00020000;
  dbSystemObject = $80000002;
  dbAttachedTable = $40000000;
  dbAttachedODBC = $20000000;
  dbHiddenObject = $00000001;

// enum QueryDefTypeEnum ̂߂̒萔
const
  dbQSelect = $00000000;
  dbQProcedure = $000000E0;
  dbQAction = $000000F0;
  dbQCrosstab = $00000010;
  dbQDelete = $00000020;
  dbQUpdate = $00000030;
  dbQAppend = $00000040;
  dbQMakeTable = $00000050;
  dbQDDL = $00000060;
  dbQSQLPassThrough = $00000070;
  dbQSetOperation = $00000080;
  dbQSPTBulk = $00000090;
  dbQCompound = $000000A0;

// enum QueryDefStateEnum ̂߂̒萔
const
  dbQPrepare = $00000001;
  dbQUnprepare = $00000002;

// enum DatabaseTypeEnum ̂߂̒萔
const
  dbVersion10 = $00000001;
  dbEncrypt = $00000002;
  dbDecrypt = $00000004;
  dbVersion11 = $00000008;
  dbVersion20 = $00000010;
  dbVersion30 = $00000020;
  dbVersion40 = $00000040;

// enum CollatingOrderEnum ̂߂̒萔
const
  dbSortNeutral = $00000400;
  dbSortArabic = $00000401;
  dbSortCyrillic = $00000419;
  dbSortCzech = $00000405;
  dbSortDutch = $00000413;
  dbSortGeneral = $00000409;
  dbSortGreek = $00000408;
  dbSortHebrew = $0000040D;
  dbSortHungarian = $0000040E;
  dbSortIcelandic = $0000040F;
  dbSortNorwdan = $00000406;
  dbSortPDXIntl = $00000409;
  dbSortPDXNor = $00000406;
  dbSortPDXSwe = $0000041D;
  dbSortPolish = $00000415;
  dbSortSpanish = $0000040A;
  dbSortSwedFin = $0000041D;
  dbSortTurkish = $0000041F;
  dbSortJapanese = $00000411;
  dbSortChineseSimplified = $00000804;
  dbSortChineseTraditional = $00000404;
  dbSortKorean = $00000412;
  dbSortThai = $0000041E;
  dbSortSlovenian = $00000424;
  dbSortUndefined = $FFFFFFFF;

// enum IdleEnum ̂߂̒萔
const
  dbFreeLocks = $00000001;
  dbRefreshCache = $00000008;

// enum PermissionEnum ̂߂̒萔
const
  dbSecNoAccess = $00000000;
  dbSecFullAccess = $000FFFFF;
  dbSecDelete = $00010000;
  dbSecReadSec = $00020000;
  dbSecWriteSec = $00040000;
  dbSecWriteOwner = $00080000;
  dbSecDBCreate = $00000001;
  dbSecDBOpen = $00000002;
  dbSecDBExclusive = $00000004;
  dbSecDBAdmin = $00000008;
  dbSecCreate = $00000001;
  dbSecReadDef = $00000004;
  dbSecWriteDef = $0001000C;
  dbSecRetrieveData = $00000014;
  dbSecInsertData = $00000020;
  dbSecReplaceData = $00000040;
  dbSecDeleteData = $00000080;

// enum SynchronizeTypeEnum ̂߂̒萔
const
  dbRepExportChanges = $00000001;
  dbRepImportChanges = $00000002;
  dbRepImpExpChanges = $00000004;
  dbRepSyncInternet = $00000010;

// enum ReplicaTypeEnum ̂߂̒萔
const
  dbRepMakeReadOnly = $00000002;
  dbRepMakePartial = $00000001;

// enum WorkspaceTypeEnum ̂߂̒萔
const
  dbUseODBC = $00000001;
  dbUseJet = $00000002;

// enum CursorDriverEnum ̂߂̒萔
const
  dbUseDefaultCursor = $FFFFFFFF;
  dbUseODBCCursor = $00000001;
  dbUseServerCursor = $00000002;
  dbUseClientBatchCursor = $00000003;
  dbUseNoCursor = $00000004;

// enum DriverPromptEnum ̂߂̒萔
const
  dbDriverPrompt = $00000002;
  dbDriverNoPrompt = $00000001;
  dbDriverComplete = $00000000;
  dbDriverCompleteRequired = $00000003;

// enum SetOptionEnum ̂߂̒萔
const
  dbPageTimeout = $00000006;
  dbLockRetry = $00000039;
  dbMaxBufferSize = $00000008;
  dbUserCommitSync = $0000003A;
  dbImplicitCommitSync = $0000003B;
  dbExclusiveAsyncDelay = $0000003C;
  dbSharedAsyncDelay = $0000003D;
  dbMaxLocksPerFile = $0000003E;
  dbLockDelay = $0000003F;
  dbRecycleLVs = $00000041;
  dbFlushTransactionTimeout = $00000042;

// enum ParameterDirectionEnum ̂߂̒萔
const
  dbParamInput = $00000001;
  dbParamOutput = $00000002;
  dbParamInputOutput = $00000003;
  dbParamReturnValue = $00000004;

// enum UpdateTypeEnum ̂߂̒萔
const
  dbUpdateBatch = $00000004;
  dbUpdateRegular = $00000001;
  dbUpdateCurrentRecord = $00000002;

// enum RecordStatusEnum ̂߂̒萔
const
  dbRecordUnmodified = $00000000;
  dbRecordModified = $00000001;
  dbRecordNew = $00000002;
  dbRecordDeleted = $00000003;
  dbRecordDBDeleted = $00000004;

// enum CommitTransOptionsEnum ̂߂̒萔
const
  dbForceOSFlush = $00000001;

// enum _DAOSuppHelp ̂߂̒萔
const
  LogMessages = $00000000;
  KeepLocal = $00000000;
  Replicable = $00000000;
  ReplicableBool = $00000000;
  V1xNullBehavior = $00000000;

function TableDefAttributeEnum2Str(const Val: integer): string;

implementation

//-----------------------------------------------------------------------------
function TableDefAttributeEnum2Str(const Val: integer): string;
begin
    Result := '';
    if (Val and dbAttachExclusive) <> 0 then Result := Result + ' dbAttachExclusive';
    if (Val and  dbAttachSavePWD) <> 0 then Result := Result + ' dbAttachSavePWD';
    if (Val and  dbSystemObject) <> 0 then Result := Result + ' dbSystemObject';
    if (Val and  dbAttachedTable) <> 0 then Result := Result + ' dbAttachedTable';
    if (Val and  dbAttachedODBC) <> 0 then Result := Result + ' dbAttachedODBC';
    if (Val and  dbHiddenObject) <> 0 then Result := Result + ' dbHiddenObject';
    Result := Trim(Result);
    if (Result = '') then Result := '@';
end;

end.

